Last Comment Bug 724292 - Android Marketplace activity opening issue
: Android Marketplace activity opening issue
Status: RESOLVED FIXED
:
Product: Firefox for Android
Classification: Client Software
Component: General (show other bugs)
: 11 Branch
: ARM Android
: P3 normal (vote)
: Firefox 13
Assigned To: Matt Brubeck (:mbrubeck)
:
Mentors:
Depends on:
Blocks: 729681
  Show dependency treegraph
 
Reported: 2012-02-04 11:37 PST by Richard Newman [:rnewman]
Modified: 2012-02-23 13:23 PST (History)
11 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---
affected
affected
fixed
11+


Attachments
Proposed patch. v1 (1.18 KB, patch)
2012-02-04 11:39 PST, Richard Newman [:rnewman]
blassey.bugs: review+
Details | Diff | Review

Description Richard Newman [:rnewman] 2012-02-04 11:37:45 PST
While testing a release test split-APK package on the market today [1], I ran into an Android issue I'm fairly sure was introduced when Sync was bundled with Fennec. After installing the package from the market, an attempt to tap 'Open' directly from the market issues a notification: "The requested item couldn't be found on this device so couldn't be launched". I'm guessing this is due to multiple activities now defined in the Android Manifest, and one of them, Fennec, I assume needs to be specified as the default launching activity. 

Starting Fennec directly from market fails. This happens on Gingerbread for me but not ICS (you also see this when installing Nightly or Fennec manually and the open button is greyed out on any platform).
Comment 1 Richard Newman [:rnewman] 2012-02-04 11:39:33 PST
Created attachment 594483 [details] [diff] [review]
Proposed patch. v1

This is for m-c. Testing now, though I can't test uploading it to the Marketplace.

Note that the alias must come *after* the Activity. If it works for me locally, I suggest applying it to Beta and rolling up a build so it can be tested properly.
Comment 2 Richard Newman [:rnewman] 2012-02-04 11:48:23 PST
Installed build APK through Browser. Android 3.2.1. Installation dialog's "Open" button launched Fennec. Tapping the Sync icon while Fennec is running takes you to… Fennec. If I force-close Fennec, tapping the Sync icon takes me to Settings. Only the setup banner in Fennec will take me straight to Sync setup.

Humph.

*resumes testing*
Comment 3 Richard Newman [:rnewman] 2012-02-04 11:59:45 PST
Actually, that's the behavior we get *now* on m-c, so it's not a regression. Behavior is identical with and without the alias definition.

If this patch helps with the Marketplace, then…

Over to someone else to try that out.

(By the way, quote in Comment 0 is from AaronMT.)
Comment 4 Richard Newman [:rnewman] 2012-02-04 12:06:17 PST
Oh, and some Stack Overflow discussion:

http://stackoverflow.com/questions/2244781/after-downloading-an-application-with-two-launcher-components-from-the-marketpla
Comment 5 Aaron Train [:aaronmt] 2012-02-04 12:43:02 PST
So, yes, main concern is that users will see the toast notification "The requested item couldn't be found on this device so couldn't be launched", as I have seen today (testing the split-release test) when tapping 'Open' once downloaded Beta from market and think the package is corrupted.
Comment 6 Erin Lancaster [:elan] 2012-02-04 14:59:29 PST
>Starting Fennec directly from market fails. This happens on Gingerbread for me but >not ICS (you also see this when installing Nightly or Fennec manually and the open >button is greyed out on any platform).

FWIW: 

- Toast notification (SplitReleaseTest from Store) = can't repro on ICS
- "Open" Button being disabled when installing Nightly manually (nightly.mozilla.org)= also can't repro on ICS
Comment 7 Aaron Train [:aaronmt] 2012-02-06 10:18:07 PST
Any update?
Comment 8 Richard Newman [:rnewman] 2012-02-06 11:29:44 PST
I've done all I can here.
Comment 9 Aaron Train [:aaronmt] 2012-02-06 14:30:14 PST
This also happens on Froyo and Eclair: "The requested item couldn't be found on this device so couldn't be launched".
Comment 10 Matt Brubeck (:mbrubeck) 2012-02-17 10:34:24 PST
Could we get rid of the separate launcher icon for Firefox Sync, and just let people access the sync activity through in-browser UI and through the system settings?
Comment 11 Richard Newman [:rnewman] 2012-02-17 14:28:54 PST
(In reply to Matt Brubeck (:mbrubeck) from comment #10)
> Could we get rid of the separate launcher icon for Firefox Sync, and just
> let people access the sync activity through in-browser UI and through the
> system settings?

Up to UX, really.

If the Fennec home screen offers affordances for both setting up Sync and pairing a new device, we're confident in their discoverability, and UX doesn't see any value in the additional entry point, then I have no significant objection.

I'd still be interested to know if this manifest change works. I would be surprised if the Fennec bundled functionality will be limited to one launcher icon for the rest of time.
Comment 12 Aaron Train [:aaronmt] 2012-02-17 14:46:51 PST
(In reply to Richard Newman [:rnewman] from comment #11)
> I'd still be interested to know if this manifest change works.

Rel-eng has a marketplace test account
Comment 13 Madhava Enros [:madhava] 2012-02-22 07:48:41 PST
(In reply to Richard Newman [:rnewman] from comment #11)
> (In reply to Matt Brubeck (:mbrubeck) from comment #10)
> > Could we get rid of the separate launcher icon for Firefox Sync, and just
> > let people access the sync activity through in-browser UI and through the
> > system settings?
> 
> Up to UX, really.
> 
> If the Fennec home screen offers affordances for both setting up Sync and
> pairing a new device, we're confident in their discoverability, and UX
> doesn't see any value in the additional entry point, then I have no
> significant objection.
> 
> I'd still be interested to know if this manifest change works. I would be
> surprised if the Fennec bundled functionality will be limited to one
> launcher icon for the rest of time.

I'm biased, caring mostly about Firefox users, but I think this would solve more problems than it creates. We can use a visual for sync as a feature within the browser (i.e. no point using a firefox icon _within_ Firefox), but then we could use the Firefox icon in place of the Sync icon in the sync settings area.

I think that most people who would understand that a sync account is a thing you can set up (without just doing it through firefox as a firefox feature) would know to look in Android Settings for it.
Comment 14 Matt Brubeck (:mbrubeck) 2012-02-22 13:25:44 PST
I tested this in my own Market account, and it works:
https://market.android.com/details?id=org.mozilla.fennec_mbrubeck

I'm landing Richard's patch, because as he says above, even if we remove the Sync icon, we'll need this if we ever add any other launcher icon in the future:
https://hg.mozilla.org/integration/mozilla-inbound/rev/053482215d7f

I filed follow-up bug 729681 to remove the Firefox Sync launcher icon.
Comment 15 Ed Morley [:emorley] 2012-02-23 13:23:32 PST
https://hg.mozilla.org/mozilla-central/rev/053482215d7f

Note You need to log in before you can comment on or make changes to this bug.